package net.minecraft.src;

public class MobSpawnerBase {
	public static final MobSpawnerBase rainforest = (new MobSpawnerBase()).func_4079_b(588342).setBiomeName("Rainforest").func_4080_a(2094168);
	public static final MobSpawnerBase swampland = (new MobSpawnerSwamp()).func_4079_b(522674).setBiomeName("Swampland").func_4080_a(9154376);
	public static final MobSpawnerBase seasonalForest = (new MobSpawnerBase()).func_4079_b(10215459).setBiomeName("Seasonal Forest");
	public static final MobSpawnerBase forest = (new MobSpawnerBase()).func_4079_b(353825).setBiomeName("Forest").func_4080_a(5159473);
	public static final MobSpawnerBase savanna = (new MobSpawnerDesert()).func_4079_b(14278691).setBiomeName("Savanna");
	public static final MobSpawnerBase shrubland = (new MobSpawnerBase()).func_4079_b(10595616).setBiomeName("Shrubland");
	public static final MobSpawnerBase taiga = (new MobSpawnerBase()).func_4079_b(3060051).setBiomeName("Taiga").func_4083_b().func_4080_a(8107825);
	public static final MobSpawnerBase desert = (new MobSpawnerDesert()).func_4079_b(16421912).setBiomeName("Desert");
	public static final MobSpawnerBase plains = (new MobSpawnerDesert()).func_4079_b(16767248).setBiomeName("Plains");
	public static final MobSpawnerBase iceDesert = (new MobSpawnerDesert()).func_4079_b(16772499).setBiomeName("Ice Desert").func_4083_b().func_4080_a(12899129);
	public static final MobSpawnerBase tundra = (new MobSpawnerBase()).func_4079_b(5762041).setBiomeName("Tundra").func_4083_b().func_4080_a(12899129);
	public static final MobSpawnerBase hell = (new MobSpawnerHell()).func_4079_b(16711680).setBiomeName("Hell");
	public String biomeName;
	public int field_6162_n;
	public byte topBlock = (byte)Block.grass.blockID;
	public byte fillerBlock = (byte)Block.dirt.blockID;
	public int field_6161_q = 5169201;
	protected Class[] biomeMonsters = new Class[]{EntitySpider.class, EntityZombie.class, EntitySkeleton.class, EntityCreeper.class};
	protected Class[] biomeCreatures = new Class[]{EntitySheep.class, EntityPig.class, EntityChicken.class, EntityCow.class};
	private static MobSpawnerBase[] biomeLookupTable = new MobSpawnerBase[4096];

	public static void generateBiomeLookup() {
		for(int var0 = 0; var0 < 64; ++var0) {
			for(int var1 = 0; var1 < 64; ++var1) {
				biomeLookupTable[var0 + var1 * 64] = getBiome((float)var0 / 63.0F, (float)var1 / 63.0F);
			}
		}

		desert.topBlock = desert.fillerBlock = (byte)Block.sand.blockID;
		iceDesert.topBlock = iceDesert.fillerBlock = (byte)Block.sand.blockID;
	}

	protected MobSpawnerBase func_4083_b() {
		return this;
	}

	protected MobSpawnerBase setBiomeName(String var1) {
		this.biomeName = var1;
		return this;
	}

	protected MobSpawnerBase func_4080_a(int var1) {
		this.field_6161_q = var1;
		return this;
	}

	protected MobSpawnerBase func_4079_b(int var1) {
		this.field_6162_n = var1;
		return this;
	}

	public static MobSpawnerBase getBiomeFromLookup(double var0, double var2) {
		int var4 = (int)(var0 * 63.0D);
		int var5 = (int)(var2 * 63.0D);
		return biomeLookupTable[var4 + var5 * 64];
	}

	public static MobSpawnerBase getBiome(float var0, float var1) {
		var1 *= var0;
		return var0 < 0.1F ? tundra : (var1 < 0.2F ? (var0 < 0.5F ? tundra : (var0 < 0.95F ? savanna : desert)) : (var1 > 0.5F && var0 < 0.7F ? swampland : (var0 < 0.5F ? taiga : (var0 < 0.97F ? (var1 < 0.35F ? shrubland : forest) : (var1 < 0.45F ? plains : (var1 < 0.9F ? seasonalForest : rainforest))))));
	}

	public Class[] getEntitiesForType(EnumCreatureType var1) {
		return var1 == EnumCreatureType.monster ? this.biomeMonsters : (var1 == EnumCreatureType.creature ? this.biomeCreatures : null);
	}

	static {
		generateBiomeLookup();
	}
}
